<?php
/*======================================================================*\
|| #################################################################### ||
|| # Youjoomla YouStorage News Slider 
|| # Youjoomla.com - YJ- Licence Number 98197-KC406000
|| # Licensed to - Hejakal Bekaudar
|| # ---------------------------------------------------------------- # ||
|| # Copyright (C) 2006-2009 Youjoomla.com. All Rights Reserved.        ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------- THIS IS NOT FREE SOFTWARE ---------------- #      ||
|| # http://www.youjoomla.com | http://www.youjoomla.com/license.html # ||
|| #################################################################### ||
\*======================================================================*/

// no direct access
defined('_JEXEC') or die('Restricted access');

JHtml::_('behavior.framework',true);
require_once (JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_content'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'route.php');
require_once(JPATH_SITE.DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.'mod_youstorage_slider'.DIRECTORY_SEPARATOR.'lib'.DIRECTORY_SEPARATOR.'slike.php');

class modYJYouStorageSliderhHelper
{
	function getYouStorageSliderItems(&$params)
	{
		
		  $get_items             = $params->get   ('get_items',1);
		  $nitems                = $params->get   ('nitems',4);
		  $chars                 = $params->get   ('chars',40);
		  $chars_nav             = $params->get   ('chars_nav',40);
		  $ordering              = $params->get   ('ordering',3);// 1 = ordering | 2 = popular | 3 = random 
		  $getspecific 	         = $params->get ('getspecific');
		  $allow_tags				= $params->get ('allow_tags');
		  $allow_tags = str_replace(" />", ">", $allow_tags);
							
		 $slider_width           = $params->get   ('slider_width','980px');
		 $slider_height          = $params->get   ('slider_height','331px');
		 $slider_intro_width     = $params->get   ('slider_intro_width','415px');
		 $slider_image_width     = $params->get   ('slider_image_width','565px');
		 $slider_image_ptop      = $params->get   ('slider_image_ptop','110px');
		 $slider_image_pleft     = $params->get   ('slider_image_pleft','150px');
						  
		 $txtDelay       		 = $params->get   ('txtDelay','10');
		 $imgOutDist     		 = $params->get   ('imgOutDist','500');
		 $txtOutDist     		 = $params->get   ('txtOutDist','300');
		 $txtFx         		 = $params->get   ('txtFx','Fx.Transitions.Pow.easeInOut');
		 $imgFx     			 = $params->get   ('imgFx','Fx.Transitions.Cubic.easeOut');
		 $txtFxDuration     	 = $params->get   ('txtFxDuration','800');
		 $imgFxDuration     	 = $params->get   ('imgFxDuration','800');
		 $autoslide    			 = $params->get   ('autoslide','0');

		$document = JFactory::getDocument();
		$document->addStyleSheet(JURI::base() . 'modules/mod_youstorage_slider/css/stylesheet.css');
		$document->addScript(JURI::base() . 'modules/mod_youstorage_slider/src/youstorage_slider12.js');

		 
		$document->addScriptDeclaration("
		window.addEvent('domready', function(){
			new YouStorageSlider({
				
				container:'slides',
				slides:{
					selector:'.slide',
					texts:'.texts',
					images:'.img_container'
				},
				navs:{
					prev:'left',
					next:'right'
				},
				txtDelay:".$txtDelay.",
				imgOutDist:".$imgOutDist.",
				txtOutDist:".$txtOutDist.",
				txtFx: ".$txtFx.",
				imgFx: ".$imgFx.",
				txtFxDuration:".$txtFxDuration.",
				imgFxDuration:".$imgFxDuration.",
				autoslide:".$autoslide."
			});
		})
		");

		/* prepare database */
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$userId		= (int) $user->get('id');
		$aid		= JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access		= !JComponentHelper::getParams('com_content')->get('show_noauth');
		$nullDate	= $db->getNullDate();
		$date =       & JFactory::getDate();
		if(intval(JVERSION) >= 3 ){	
			$now =         $date->toSql() ; 
		}else{
			$now =         $date->toMySQL(); 
		}
		
		
		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;
		// select specific items
		if(!empty($getspecific)){
		$countitems = count($getspecific);
		}
		if(!empty($getspecific) && $countitems > 1 ){
			$specificitems = implode(",", $getspecific);
			$specific_order= 'field(a.id,'.$specificitems.')';
			$where .= ' AND a.id IN ('.$specificitems.')';
		}elseif(!empty($getspecific) && $countitems == 1 ){
			$specificitems = $getspecific[0];
			$specific_order= 'field(a.id,'.$specificitems.')';
			$where .= ' AND a.id IN ('.$specificitems.')';
		}else{
			$specificitems='';
			$specific_order='NULL';
			$where .= ' AND cc.id = '.$get_items.'';
		}
		/* set items order */
		$ord = array(
			1=>'ordering',
			2=>'hits',
			3=>'RAND()',
			4=>'created ASC',
			5=>'created DESC',
			6=>$specific_order
		);
		$order = $ord[$ordering];
			/* get items */
		$sql = 	'SELECT a.*, ' .
				' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'. 
				' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,'.
				'cc.title as cattitle'.
		
				' FROM #__content AS a' .
				' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
				' WHERE '. $where .'' .
				($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid : '').
				' AND cc.published = 1' .
				' ORDER BY '.$order .' LIMIT 0,'.$nitems.'';
		$db->setQuery( $sql );
		$load_items = $db->loadObjectList();
		
		
		$youstorage_slides = array();
		foreach ( $load_items as $row ) {
			$youstorage_slide = array(
					'intro' => substr(strip_tags($row->introtext,''.$allow_tags.''),0,$chars),
					'link' => htmlspecialchars(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug), ENT_QUOTES, 'UTF-8'),
					'title' => htmlspecialchars($row->title, ENT_QUOTES, 'UTF-8'),
					'img_url' => $img_url = article_imageyoustor($row),
					'img_out' => "<img src=\"".$img_url."\" title=\"".$row->title." \"  alt=\"\"/>"
				);
				$youstorage_slides[] = $youstorage_slide;
		}
		
				return $youstorage_slides;
	}
}
?>